<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<!--
IGAC proyecto SNC

@author  pedro.garcia
@description  página que muestra la información de qué tiene un recolector por hacer
@cu  CU-TV-0F-002
@version  2.0

-->


<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:p="http://primefaces.org/ui"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="/templates/generalCU.xhtml">

    <ui:define name="title">.::Sistema Nacional Catastral::. .::Asignación de recolector a área de oferta::.</ui:define>
    <ui:define name="content">

        <h:outputScript library="javascript" name="snc_visor_client.js"
                        target="head" />
        <h:outputStylesheet library="css" name="snc_visor_client.css" />

        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" onerror="statusDialog.hide();" />

        <!-- Input para enviar parámetro con dato de rural o urbano -->
        <h:inputHidden id="idOfertaMapa"
                       value="#{asignacionRecolector.idsAreasOferta}" />

        <!-- Input para enviar parámetro con dato de rural o urbano -->
        <h:inputHidden id="predioRuralOfertasMapa"
                       value="#{asignacionRecolector.banderaRural}" />

        <h:form id="informacionRecolectoresForm">
            <p:focus />
            <p:messages id="msgsAAO" showDetail="false" globalOnly="false" />

            <p:fieldset id="regionesCreadasFS">

                <legend>
                    <h:outputText styleClass="legendTitle"
                                  value="Regiones para recolección de ofertas" />
                </legend>

                <h:panelGrid columns="1" cellspacing="7" width="100%">

                    <p:dataTable id="regionesAreaDT" widgetVar="regionesAreaWV"
                                 value="#{asignacionRecolector.regionesCapturaArea}" var="region"
                                 paginator="true" rows="10"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink}
                                 {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="10,20,50" paginatorPosition="bottom"
                                 selection="#{asignacionRecolector.regionSeleccionada}"
                                 rowKey="#{region.id}"
                                 emptyMessage="No hay regiones de captura asociadas a esta área">

                        <p:ajax event="rowSelect" update=":informacionRecolectoresForm" />

                        <p:ajax event="rowUnselect" update=":informacionRecolectoresForm" />

                        <f:facet name="header">
                            <h:outputText value="Regiones para recolección de ofertas" />
                        </f:facet>

                        <p:column selectionMode="single" style="width:18px" />

                        <p:column headerText="Opciones">
                            <p:commandButton id="visorGIS" widgetVar="verMapaVar"
                                             title="Zoom a la región" icon="ui-icon ui-icon-zoomin"
                                             onclick="cargarMapaZoomToFeature('#{asignacionRecolector.applicationClientName}',
                                                             '#{asignacionRecolector.tokenParam}',
                                                             '#{asignacionRecolector.moduleLayer}',
                                                             '#{asignacionRecolector.moduleTools}',
                                                             '#{region.cadenaDeManzanasVeredas}');"
                                             disabled="#{empty region.detalleCapturaOfertas}" process="@this" />

                            <p:commandButton title="Desasignar recolector"
                                             icon="ui-icon-circle-minus"
                                             action="#{asignacionRecolector.desasignarRecolector}"
                                             onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide();"
                                             update=":informacionRecolectoresForm"
                                             disabled="#{empty region.asignadoRecolectorId}">
                                <f:setPropertyActionListener value="#{region}"
                                                             target="#{asignacionRecolector.regionSeleccionada}" />
                            </p:commandButton>

                        </p:column>

                        <p:column headerText="Identificador" sortBy="#{region.id}">
                            <h:outputText value="#{region.id}" styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Recolector asignado"
                                  sortBy="#{region.asignadoRecolectorNombre}">
                            <h:outputText value="#{region.asignadoRecolectorNombre}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Fecha creación de la región">
                            <h:outputText value="#{region.fechaAsignacionRecolector}"
                                          styleClass="outputTextStyle">
                                <f:convertDateTime pattern="#{general.formatoFechaUsuario2}"
                                                   timeZone="GMT-5" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Estado" filterBy="#{region.estado}">
                            <h:outputText value="#{region.estado}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Observaciones">
                            <h:outputText value="#{region.observaciones}"
                                          styleClass="outputTextStyle" />
                        </p:column>


                    </p:dataTable>

                </h:panelGrid>

                <h:panelGrid columns="1" cellspacing="7">

                    <p:commandButton value="Crear región de captura"
                                     icon="ui-icon-circle-plus"
                                     action="#{asignacionRecolector.cargarVentanaCreacion}"
                                     onstart="statusDialog2.show();"
                                     oncomplete="statusDialog2.hide(); 
                                     handleCompleteSIC(xhr, status, args, crearRegionWV, true);"
                                     update=":informacionRecolectoresForm:msgsAAO,
                                     :creacionRegionRecoleccionForm" />

                </h:panelGrid>

            </p:fieldset>

            <p:spacer height="10" width="0" />

            <p:fieldset id="asignacionConsultaDesasignacionFS"
                        rendered="#{not empty asignacionRecolector.regionesCapturaArea and 
                                    not empty asignacionRecolector.regionSeleccionada}">

                <legend>
                    <h:outputText styleClass="legendTitle"
                                  value="Información de recolectores" />
                </legend>

                <h:panelGrid columns="1" cellspacing="7" width="100%">

                    <p:dataTable id="listaRecolectoresId"
                                 widgetVar="listaRecolectoresWV"
                                 value="#{asignacionRecolector.listaRecolectores}" var="recolector"
                                 paginator="true" rows="10"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink}
                                 {PageLinks} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="10,20,50" paginatorPosition="bottom"
                                 selection="#{asignacionRecolector.recolectorSeleccionado}"
                                 rowKey="#{recolector.id}" emptyMessage="No hay recolectores">

                        <p:ajax event="rowSelect"
                                update=":informacionRecolectoresForm:botonesRegionesPG" />

                        <p:ajax event="rowUnselect"
                                update=":informacionRecolectoresForm:botonesRegionesPG" />

                        <f:facet name="header">
                            <h:outputText value="Información de los recolectores" />
                        </f:facet>

                        <p:column selectionMode="single" style="width:18px" />

                        <p:column headerText="Opciones">

                            <p:commandButton icon="ui-icon-search"
                                             title="Consultar áreas del recolector"
                                             action="#{asignacionRecolector.cargarVentanaConsulta}"
                                             onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide(); areasDeRecolectorWV.show();"
                                             update=":areasRecolectorForm:regionesRecolectorSeleccionadoDT"
                                             disabled="#{recolector.tieneAsignaciones eq 'SI' ? false : true}">
                                <f:setPropertyActionListener value="#{recolector}"
                                                             target="#{asignacionRecolector.recolectorSeleccionado}" />
                            </p:commandButton>

                        </p:column>

                        <p:column headerText="Nombre"
                                  sortBy="#{recolector.nombreFuncionario}">
                            <h:outputText value="#{recolector.nombreFuncionario}"
                                          styleClass="outputTextStyle" />
                        </p:column>


                        <p:column headerText="¿Tiene asignaciones?">
                            <h:outputText value="#{recolector.tieneAsignaciones}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                    </p:dataTable>

                </h:panelGrid>
                <h:panelGrid columns="1" cellspacing="7" id="botonesRegionesPG">

                    <p:commandButton value="Asignar recolector" icon="ui-icon-disk"
                                     action="#{asignacionRecolector.asignarRecolector}"
                                     onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();"
                                     update=":informacionRecolectoresForm"
                                     disabled="#{empty asignacionRecolector.recolectorSeleccionado || 
                                                 empty asignacionRecolector.regionSeleccionada}" />
                </h:panelGrid>

            </p:fieldset>



            <p:separator style="width:925px;height:3px" />
            <p:spacer height="7" width="0" />
            <p:outputPanel layout="block" style="text-align:right">
                <p:commandButton value="Cerrar"
                                 action="#{asignacionRecolector.cerrar}" icon="ui-icon-circle-close"
                                 immediate="true" ajax="false" />
                <p:spacer height="0" width="30" />
            </p:outputPanel>
            <p:spacer height="20" width="0" />

        </h:form>

        <!-- ...................... dialogs  ................................... -->

        <!-- Dialog para asignacion de recolector a área -->
        <p:dialog widgetVar="crearRegionWV" header="Crear región de captura"
                  appendToBody="true" closable="true" dynamic="true" resizable="false"
                  minimizable="false" width="350" modal="true"
                  position="#{asignacionRecolector.posicionVentanaInformacionRegion}">
            <ui:include src="creacionRegionRecoleccion.xhtml" />
        </p:dialog>

        <!-- Dialog para asignacion de recolector a área -->
        <p:dialog widgetVar="areasDeRecolectorWV" id="areasDeRecolectorDialog"
                  header="Áreas por Recolector" appendToBody="true" closable="true"
                  dynamic="true" resizable="false" minimizable="false" width="500">
            <ui:include src="areasRecolector.xhtml" />
        </p:dialog>

        <misc:ultimateConfirmDialogCC id="mensajeConfirmacion"
                                      confirmMessage="¿Desea desasignar todo?"
                                      confirmUpdateOnYes=":areasRecolectorForm"
                                      confirmDialogWV="desasignarRegionesConfirmationWV"
                                      voidActionOnYes="#{asignacionRecolector.desasignarTodasRegiones}"
                                      width="330" 
                                      useStringActionOnYes="false" useStringActionOnNo="false" actionOnNoIsClose="true"/>

        <ui:include src="/util/visorGeografico.xhtml" />


    </ui:define>
</ui:composition>
